<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__log_8h" kind="file" language="C++">
    <compoundname>cy_log.h</compoundname>
    <includes local="no">stdarg.h</includes>
    <includes local="yes">cy_result.h</includes>
    <incdepgraph>
      <node id="9">
        <label>stdarg.h</label>
      </node>
      <node id="10">
        <label>cy_result.h</label>
      </node>
      <node id="8">
        <label>cy_log.h</label>
        <link refid="cy__log_8h" />
        <childnode refid="9" relation="include">
        </childnode>
        <childnode refid="10" relation="include">
        </childnode>
      </node>
    </incdepgraph>
      <sectiondef kind="enum">
      <memberdef id="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca" kind="enum" prot="public" static="no">
        <name>CY_LOG_LEVEL_T</name>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa7588515858913436f69df5dfa9249cac" prot="public">
          <name>CY_LOG_OFF</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>Do not print log messages. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa996365b0f0146f33926ac7fb90affcf8" prot="public">
          <name>CY_LOG_ERR</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_ERR. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa6aecfc9626666a5ff9835004ad6edac5" prot="public">
          <name>CY_LOG_WARNING</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_WARNING. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa0c837ef1eec006b465dcfc8473f92856" prot="public">
          <name>CY_LOG_NOTICE</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_NOTICE. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaabab5f949c995aa165944d87c5bd97c75" prot="public">
          <name>CY_LOG_INFO</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_INFO. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa18166fefe710a7648ecb4b96ce64b982" prot="public">
          <name>CY_LOG_DEBUG</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_DEBUG. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa2e135ee8848affea6af3999c33f767eb" prot="public">
          <name>CY_LOG_DEBUG1</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_DEBUG1. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaaca8359f2ee1f32a16fd28b21b4a80433" prot="public">
          <name>CY_LOG_DEBUG2</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_DEBUG2. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa74c923c2b889250c5aeb6b4ced434e3e" prot="public">
          <name>CY_LOG_DEBUG3</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_DEBUG3. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa280d129c0c7d6404dcd51a161ab5ae01" prot="public">
          <name>CY_LOG_DEBUG4</name>
          <briefdescription>
<para>Print log message if run-time level is &lt;= CY_LOG_DEBUG4. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaaede2e683f0d4b2bd165c16aef557e27b" prot="public">
          <name>CY_LOG_PRINTF</name>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa98429ec05a2972af8a784c6939f3ab7f" prot="public">
          <name>CY_LOG_MAX</name>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>CY_LOG_LEVEL_T: </bold><linebreak />Logging levels.</para></briefdescription>
        <detaileddescription>
<para>NOTE: Default value for all facilities is passed in to init call </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="114" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" bodystart="98" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="99" />
      </memberdef>
      <memberdef id="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a" kind="enum" prot="public" static="no">
        <name>CY_LOG_FACILITY_T</name>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aaf86bda115d86421bd084eb430a58398d" prot="public">
          <name>CYLF_DEF</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>General log message not associated with any specific Facility. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aaa37298761ce8e5e54c7d4b846749bf23" prot="public">
          <name>CYLF_TEST</name>
          <briefdescription>
<para>Test Facility. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aa8fc222822bee9e8181de5d3ecb49c897" prot="public">
          <name>CYLF_DRIVER</name>
          <briefdescription>
<para>Driver Facility. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aa6dac3469fd1ab51514c3d234331d14fa" prot="public">
          <name>CYLF_LP</name>
          <briefdescription>
<para>Low Power Facility. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aa216bc23cb3ac611d20e07862c4de9599" prot="public">
          <name>CYLF_MIDDLEWARE</name>
          <briefdescription>
<para>Middleware Facility. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aae90d349e5b044251f374b26de4e3254f" prot="public">
          <name>CYLF_AUDIO</name>
          <briefdescription>
<para>Audio Facility. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aacfaab6a87a264a6c5984f0131728cdda" prot="public">
          <name>CYLF_MAX</name>
          <briefdescription>
<para>Must be last, not an actual index. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>CY_LOG_FACILITY_T: </bold><linebreak />Log Facility type Log facilities allow for separate subsystems to have different run-time log levels for output.</para></briefdescription>
        <detaileddescription>
<para>This allows for someone working in the Driver subsystem to turn on DEBUG level without turning DEBUG level for middleware - makes for less unwanted output during debugging / testing. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="131" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" bodystart="121" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="122" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5" kind="typedef" prot="public" static="no">
        <type>int(*</type>
        <definition>typedef int(* log_output) (CY_LOG_FACILITY_T facility, CY_LOG_LEVEL_T level, char *logmsg)</definition>
        <argsstring>)(CY_LOG_FACILITY_T facility, CY_LOG_LEVEL_T level, char *logmsg)</argsstring>
        <name>log_output</name>
        <briefdescription>
<para>Prototype for application callback to use the logging message. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" bodystart="148" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="148" />
      </memberdef>
      <memberdef id="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73" kind="typedef" prot="public" static="no">
        <type>cy_rslt_t(*</type>
        <definition>typedef cy_rslt_t(* platform_get_time) (uint32_t *time)</definition>
        <argsstring>)(uint32_t *time)</argsstring>
        <name>platform_get_time</name>
        <briefdescription>
<para>Prototype for application callback to get current time in milliseconds. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" bodystart="152" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="152" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga58651ec3d45e88bcf22ad57a7122502b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_init</definition>
        <argsstring>(CY_LOG_LEVEL_T level, log_output platform_output, platform_get_time platform_time)</argsstring>
        <name>cy_log_init</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref></type>
          <declname>platform_output</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref></type>
          <declname>platform_time</declname>
        </param>
        <briefdescription>
<para>Initialize the logging subsystem. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: The initial logging level to use for all facilities. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">platform_output</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the function invoked by the library to output the log messages. If this argument is passed as NULL, the library prints the log output on the standard output stream (stdio). </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">platform_time</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the function invoked by the library to get the time. If this argument is passed as NULL, the library calls <ulink url="https://cypresssemiconductorco.github.io/abstraction-rtos/html/group__group__abstraction__rtos__time.html">cy_rtos_get_time</ulink> function to get the time required for logging.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="180" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga9df08670a49c78224aa1826fd0be54fb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_shutdown</definition>
        <argsstring>(void)</argsstring>
        <name>cy_log_shutdown</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Shutdown the logging subsystem. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="186" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga43ee69c5e9ac44d917a27a1e49bd7098" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_platform_output</definition>
        <argsstring>(log_output platform_output)</argsstring>
        <name>cy_log_set_platform_output</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref></type>
          <declname>platform_output</declname>
        </param>
        <briefdescription>
<para>Set the platform output routine for log messages. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If platform_output is NULL, log messages will be discarded.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">platform_output</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the platform output routine for log messages.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="196" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga28fef2ede13ef8109e6b27805ac8f749" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_platform_time</definition>
        <argsstring>(platform_get_time platform_time)</argsstring>
        <name>cy_log_set_platform_time</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref></type>
          <declname>platform_time</declname>
        </param>
        <briefdescription>
<para>Set the platform routine for getting time stamps for log messages. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If platform_time is NULL, cy_time_get_time() is used for time stamps.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">platform_time</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to a platform time routine for log message time stamps.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="206" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1gaa063d8ccda8314098cfca1f983197a52" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_facility_level</definition>
        <argsstring>(CY_LOG_FACILITY_T facility, CY_LOG_LEVEL_T level)</argsstring>
        <name>cy_log_set_facility_level</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref></type>
          <declname>facility</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <briefdescription>
<para>Set the logging level for a facility. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">facility</parametername>
</parameternamelist>
<parameterdescription>
<para>: The facility for which to set the log level. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: The new log level to use.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="215" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga35ea5f0b250f8e2b7fea35f031b6ee06" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_all_levels</definition>
        <argsstring>(CY_LOG_LEVEL_T level)</argsstring>
        <name>cy_log_set_all_levels</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <briefdescription>
<para>Set the logging level for all facilities. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: The new log level to use.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="223" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga6b4f9cc32c62adaac3dd357b869c59a1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
        <definition>CY_LOG_LEVEL_T cy_log_get_facility_level</definition>
        <argsstring>(CY_LOG_FACILITY_T facility)</argsstring>
        <name>cy_log_get_facility_level</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref></type>
          <declname>facility</declname>
        </param>
        <briefdescription>
<para>Get the logging level for a facility. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">facility</parametername>
</parameternamelist>
<parameterdescription>
<para>: The facility for which to return the log level.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The current log level. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="231" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1gac30db641e4001edf1692b13e75cb0659" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_msg</definition>
        <argsstring>(CY_LOG_FACILITY_T facility, CY_LOG_LEVEL_T level, const char *fmt,...)</argsstring>
        <name>cy_log_msg</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref></type>
          <declname>facility</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <param>
          <type>const char *</type>
          <declname>fmt</declname>
        </param>
        <param>
          <type>...</type>
        </param>
        <briefdescription>
<para>Write a log message. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The format arguments are the same as for printf.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">facility</parametername>
</parameternamelist>
<parameterdescription>
<para>: The facility for the log message. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: Log level of the message. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">fmt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Format control string followed by any optional arguments.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="243" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga7a2cc061bf37ae6a1538b80b38bb88ca" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_printf</definition>
        <argsstring>(const char *fmt,...)</argsstring>
        <name>cy_log_printf</name>
        <param>
          <type>const char *</type>
          <declname>fmt</declname>
        </param>
        <param>
          <type>...</type>
        </param>
        <briefdescription>
<para>Write a log message bypassing the log level check. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The format arguments are the same as for printf.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">fmt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Format control string followed by any optional arguments.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="253" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1gab9d1cb336ea7bb6b51b37d7d06b5f891" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_vprintf</definition>
        <argsstring>(const char *fmt, va_list varg)</argsstring>
        <name>cy_log_vprintf</name>
        <param>
          <type>const char *</type>
          <declname>fmt</declname>
        </param>
        <param>
          <type>va_list</type>
          <declname>varg</declname>
        </param>
        <briefdescription>
<para>Write a log message bypassing the log level check using va_list. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The format arguments are the same as for vprintf.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">fmt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Format control string. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">varg</parametername>
</parameternamelist>
<parameterdescription>
<para>: va_list of arguments.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="264" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>A logging subsystem that allows run time control for the logging level. </para>    </briefdescription>
    <detaileddescription>
<para>Log messages are passed back to the application for output. Log messages are given sequence numbers. A time callback can be provided by the application for the timestamp for each output line. Log messages are mutex protected across threads so that log messages do not interrupt each other. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/*</highlight></codeline>
<codeline lineno="2"><highlight class="comment"><sp />*<sp />$<sp />Copyright<sp />2019-YEAR<sp />Cypress<sp />Semiconductor<sp />Apache2<sp />$</highlight></codeline>
<codeline lineno="3"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="4"><highlight class="normal" /></codeline>
<codeline lineno="13"><highlight class="comment">/*</highlight></codeline>
<codeline lineno="14"><highlight class="comment"><sp />*<sp />in<sp />Main<sp />application<sp />file:</highlight></codeline>
<codeline lineno="15"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="16"><highlight class="comment"><sp />*<sp /><sp />Log<sp />output<sp />callback<sp />function<sp />-<sp />The<sp />App<sp />decides<sp />what<sp />and<sp />how<sp />logging<sp />is<sp />to<sp />be<sp />output</highlight></codeline>
<codeline lineno="17"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="18"><highlight class="comment"><sp />*<sp /><sp />int<sp />app_log_output_callback(CY_LOG_FACILITY_T<sp />facility,<sp />CY_LOG_LEVEL_T<sp />level,<sp />char<sp />*logmsg)</highlight></codeline>
<codeline lineno="19"><highlight class="comment"><sp />*<sp /><sp />{</highlight></codeline>
<codeline lineno="20"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />(void)facility;<sp /><sp /><sp /><sp /><sp />//<sp />Can<sp />be<sp />used<sp />to<sp />decide<sp />to<sp />reduce<sp />output<sp />or<sp />send<sp />output<sp />to<sp />remote<sp />logging</highlight></codeline>
<codeline lineno="21"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />(void)level;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />//<sp />Can<sp />be<sp />used<sp />to<sp />decide<sp />to<sp />reduce<sp />output,<sp />although<sp />the<sp />output<sp />has<sp />already<sp />been</highlight></codeline>
<codeline lineno="22"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />//<sp />limited<sp />by<sp />the<sp />log<sp />routines</highlight></codeline>
<codeline lineno="23"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="24"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />return<sp />printf(<sp />"%s\n",<sp />logmsg);<sp /><sp /><sp />//<sp />print<sp />directly<sp />to<sp />console</highlight></codeline>
<codeline lineno="25"><highlight class="comment"><sp />*<sp /><sp />}</highlight></codeline>
<codeline lineno="26"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="27"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="28"><highlight class="comment"><sp />*<sp /><sp />Log<sp />time<sp />callback<sp />-<sp />get<sp />the<sp />current<sp />time<sp />for<sp />the<sp />log<sp />message<sp />timestamp<sp />in<sp />millseconds</highlight></codeline>
<codeline lineno="29"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="30"><highlight class="comment"><sp />*<sp /><sp />cy_rslt_t<sp />app_log_time(uint32_t*<sp />time)</highlight></codeline>
<codeline lineno="31"><highlight class="comment"><sp />*<sp /><sp />{</highlight></codeline>
<codeline lineno="32"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />if<sp />(time<sp />!=<sp />NULL)</highlight></codeline>
<codeline lineno="33"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="34"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*time<sp />=<sp />get_time_ms();<sp />//<sp />get<sp />system<sp />time<sp />(in<sp />milliseconds)</highlight></codeline>
<codeline lineno="35"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="36"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />return<sp />CY_RSLT_SUCCESS;</highlight></codeline>
<codeline lineno="37"><highlight class="comment"><sp />*<sp /><sp />}</highlight></codeline>
<codeline lineno="38"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="39"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="40"><highlight class="comment"><sp />*<sp /><sp />Log<sp />initialization<sp />-<sp />default<sp />os<sp />OFF,<sp />no<sp />output<sp />from<sp />any<sp />facility</highlight></codeline>
<codeline lineno="41"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="42"><highlight class="comment"><sp />*<sp /><sp />result<sp />=<sp />cy_log_init(CY_LOG_OFF,<sp />app_log_output_callback,<sp />app_log_time);</highlight></codeline>
<codeline lineno="43"><highlight class="comment"><sp />*<sp /><sp />if<sp />(result<sp />!=<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="44"><highlight class="comment"><sp />*<sp /><sp />{</highlight></codeline>
<codeline lineno="45"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp />printf("cy_log_init()<sp />FAILED<sp />%ld\n",<sp />result);</highlight></codeline>
<codeline lineno="46"><highlight class="comment"><sp />*<sp /><sp />}</highlight></codeline>
<codeline lineno="47"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="48"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="49"><highlight class="comment"><sp />*<sp /><sp />Example<sp />using<sp />TEST<sp />facility</highlight></codeline>
<codeline lineno="50"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="51"><highlight class="comment"><sp />*<sp /><sp />cy_log_set_facility_level(CYLF_TEST,<sp />CY_LOG_WARNING);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />//<sp />set<sp />log<sp />message<sp />level<sp />to<sp />WARNING</highlight></codeline>
<codeline lineno="52"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="53"><highlight class="comment"><sp />*<sp /><sp />cy_log_printf("TEST<sp />message:<sp />always<sp />print.");<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />//<sp />Bypass<sp />facility/level<sp />check<sp />and<sp />always<sp />print<sp />message</highlight></codeline>
<codeline lineno="54"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />//<sp />calls<sp />app_log_output_callback(CYLF_DEF,<sp />CY_LOG_PRINTF,<sp />logmsg)</highlight></codeline>
<codeline lineno="55"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="56"><highlight class="comment"><sp />*<sp /><sp />cy_log_msg(CYLF_TEST,<sp />CY_LOG_ERR,<sp /><sp /><sp /><sp /><sp />"TEST<sp />message:<sp />ERR");<sp /><sp /><sp /><sp /><sp />//<sp />Print<sp />if<sp />CYLF_TEST<sp />level<sp />is<sp />CY_LOG_ERR<sp />or<sp />higher</highlight></codeline>
<codeline lineno="57"><highlight class="comment"><sp />*<sp /><sp />cy_log_msg(CYLF_TEST,<sp />CY_LOG_WARNING,<sp />"TEST<sp />message:<sp />WARNING");<sp />//<sp />Print<sp />if<sp />CYLF_TEST<sp />level<sp />is<sp />CY_LOG_WARNING<sp />or<sp />higher</highlight></codeline>
<codeline lineno="58"><highlight class="comment"><sp />*<sp /><sp />cy_log_msg(CYLF_TEST,<sp />CY_LOG_NOTICE,<sp /><sp />"TEST<sp />message:<sp />NOTICE");<sp /><sp />//<sp />Print<sp />if<sp />CYLF_TEST<sp />level<sp />is<sp />CY_LOG_NOTICE<sp />or<sp />higher</highlight></codeline>
<codeline lineno="59"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="60"><highlight class="comment"><sp />*<sp /><sp />cy_log_msg(CYLF_DRIVER,<sp />CY_LOG_ERR,<sp /><sp /><sp />"DRIVER<sp />message:<sp />ERR");<sp /><sp /><sp />//<sp />Print<sp />if<sp />CYLF_DRIVER<sp />level<sp />is<sp />CY_LOG_ERR<sp />or<sp />higher</highlight></codeline>
<codeline lineno="61"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="62"><highlight class="comment"><sp />*<sp /><sp />OUTPUT:</highlight></codeline>
<codeline lineno="63"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="64"><highlight class="comment"><sp />*<sp /><sp />TEST<sp />message:<sp />always<sp />print.</highlight></codeline>
<codeline lineno="65"><highlight class="comment"><sp />*<sp /><sp />TEST<sp />message:<sp />ERR</highlight></codeline>
<codeline lineno="66"><highlight class="comment"><sp />*<sp /><sp />TEST<sp />message:<sp />WARNING</highlight></codeline>
<codeline lineno="67"><highlight class="comment"><sp />*</highlight></codeline>
<codeline lineno="68"><highlight class="comment"><sp />*<sp /><sp />-<sp />No<sp />other<sp />CYLF_TEST<sp />output<sp />due<sp />to<sp />level<sp />set<sp />as<sp />CY_LOG_WARNING</highlight></codeline>
<codeline lineno="69"><highlight class="comment"><sp />*<sp /><sp />-<sp />No<sp />CYLF_DRIVER<sp />output<sp />due<sp />to<sp />level<sp />set<sp />as<sp />CY_LOG_OFF</highlight></codeline>
<codeline lineno="70"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal" /><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdarg.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_result.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="79"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="82"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Macros</highlight></codeline>
<codeline lineno="83"><highlight class="comment"><sp />******************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="84"><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="86"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Constants</highlight></codeline>
<codeline lineno="87"><highlight class="comment"><sp />******************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="90"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Enumerations</highlight></codeline>
<codeline lineno="91"><highlight class="comment"><sp />******************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal" /></codeline>
<codeline lineno="93"><highlight class="normal" /><highlight class="comment">/******************************************************************************/</highlight></codeline>
<codeline lineno="95"><highlight class="comment">/******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="96"><highlight class="normal" /></codeline>
<codeline lineno="98"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="99"><highlight class="normal">{</highlight></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa7588515858913436f69df5dfa9249cac">CY_LOG_OFF</ref><sp />=<sp />0,<sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="101"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa996365b0f0146f33926ac7fb90affcf8">CY_LOG_ERR</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa6aecfc9626666a5ff9835004ad6edac5">CY_LOG_WARNING</ref>,<sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa0c837ef1eec006b465dcfc8473f92856">CY_LOG_NOTICE</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaabab5f949c995aa165944d87c5bd97c75">CY_LOG_INFO</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa18166fefe710a7648ecb4b96ce64b982">CY_LOG_DEBUG</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa2e135ee8848affea6af3999c33f767eb">CY_LOG_DEBUG1</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaaca8359f2ee1f32a16fd28b21b4a80433">CY_LOG_DEBUG2</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa74c923c2b889250c5aeb6b4ced434e3e">CY_LOG_DEBUG3</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga51a7f6067daa4d3c75fd5ee654737fcaa280d129c0c7d6404dcd51a161ab5ae01">CY_LOG_DEBUG4</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp />CY_LOG_PRINTF,<sp /></highlight><highlight class="comment">/*<sp />Identifies<sp />log<sp />messages<sp />generated<sp />by<sp />cy_log_printf<sp />calls<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="112"><highlight class="normal" /></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp />CY_LOG_MAX</highlight></codeline>
<codeline lineno="114"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref>;</highlight></codeline>
<codeline lineno="115"><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="122"><highlight class="normal">{</highlight></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aaf86bda115d86421bd084eb430a58398d">CYLF_DEF</ref><sp />=<sp />0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aaa37298761ce8e5e54c7d4b846749bf23">CYLF_TEST</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aa8fc222822bee9e8181de5d3ecb49c897">CYLF_DRIVER</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aa6dac3469fd1ab51514c3d234331d14fa">CYLF_LP</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aa216bc23cb3ac611d20e07862c4de9599">CYLF_MIDDLEWARE</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aae90d349e5b044251f374b26de4e3254f">CYLF_AUDIO</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__logging__enums_1gga77dcf80196a559e0918a18c45b326f3aacfaab6a87a264a6c5984f0131728cdda">CYLF_MAX</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="131"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref>;</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /></codeline>
<codeline lineno="135"><highlight class="comment">/******************************************************************************/</highlight></codeline>
<codeline lineno="137"><highlight class="comment">/******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal" /></codeline>
<codeline lineno="139"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="140"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Structures</highlight></codeline>
<codeline lineno="141"><highlight class="comment"><sp />******************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="142"><highlight class="normal" /></codeline>
<codeline lineno="143"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="144"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Type<sp />Definitions</highlight></codeline>
<codeline lineno="145"><highlight class="comment"><sp />******************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal" /></codeline>
<codeline lineno="148"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp />int<sp />(*<ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref>)(CY_LOG_FACILITY_T<sp />facility,<sp />CY_LOG_LEVEL_T<sp />level,<sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*logmsg);</highlight></codeline>
<codeline lineno="149"><highlight class="normal" /></codeline>
<codeline lineno="152"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp />cy_rslt_t<sp />(*<ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref>)(uint32_t*<sp />time);</highlight></codeline>
<codeline lineno="153"><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="comment">/*****************************************************************************/</highlight></codeline>
<codeline lineno="165"><highlight class="comment">/*****************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="166"><highlight class="normal" /><highlight class="comment">/******************************************************</highlight></codeline>
<codeline lineno="167"><highlight class="comment"><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Function<sp />Declarations</highlight></codeline>
<codeline lineno="168"><highlight class="comment"><sp />******************************************************/</highlight></codeline>
<codeline lineno="180"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1ga58651ec3d45e88bcf22ad57a7122502b">cy_log_init</ref>(CY_LOG_LEVEL_T<sp />level,<sp /><ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref><sp />platform_output,<sp /><ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref><sp />platform_time);</highlight></codeline>
<codeline lineno="181"><highlight class="normal" /></codeline>
<codeline lineno="186"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1ga9df08670a49c78224aa1826fd0be54fb">cy_log_shutdown</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="187"><highlight class="normal" /></codeline>
<codeline lineno="196"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1ga43ee69c5e9ac44d917a27a1e49bd7098">cy_log_set_platform_output</ref>(<ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref><sp />platform_output);</highlight></codeline>
<codeline lineno="197"><highlight class="normal" /></codeline>
<codeline lineno="206"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1ga28fef2ede13ef8109e6b27805ac8f749">cy_log_set_platform_time</ref>(<ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref><sp />platform_time);</highlight></codeline>
<codeline lineno="207"><highlight class="normal" /></codeline>
<codeline lineno="215"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1gaa063d8ccda8314098cfca1f983197a52">cy_log_set_facility_level</ref>(CY_LOG_FACILITY_T<sp />facility,<sp />CY_LOG_LEVEL_T<sp />level);</highlight></codeline>
<codeline lineno="216"><highlight class="normal" /></codeline>
<codeline lineno="223"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1ga35ea5f0b250f8e2b7fea35f031b6ee06">cy_log_set_all_levels</ref>(CY_LOG_LEVEL_T<sp />level);</highlight></codeline>
<codeline lineno="224"><highlight class="normal" /></codeline>
<codeline lineno="231"><highlight class="normal">CY_LOG_LEVEL_T<sp /><ref kindref="member" refid="group__group__logging__func_1ga6b4f9cc32c62adaac3dd357b869c59a1">cy_log_get_facility_level</ref>(CY_LOG_FACILITY_T<sp />facility);</highlight></codeline>
<codeline lineno="232"><highlight class="normal" /></codeline>
<codeline lineno="243"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1gac30db641e4001edf1692b13e75cb0659">cy_log_msg</ref>(CY_LOG_FACILITY_T<sp />facility,<sp />CY_LOG_LEVEL_T<sp />level,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*fmt,<sp />...);</highlight></codeline>
<codeline lineno="244"><highlight class="normal" /></codeline>
<codeline lineno="253"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1ga7a2cc061bf37ae6a1538b80b38bb88ca">cy_log_printf</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*fmt,<sp />...);</highlight></codeline>
<codeline lineno="254"><highlight class="normal" /></codeline>
<codeline lineno="264"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__logging__func_1gab9d1cb336ea7bb6b51b37d7d06b5f891">cy_log_vprintf</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*fmt,<sp />va_list<sp />varg);</highlight></codeline>
<codeline lineno="265"><highlight class="normal" /></codeline>
<codeline lineno="268"><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal">}<sp /></highlight><highlight class="comment">/*<sp />extern<sp />"C"<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="270"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" />
  </compounddef>
</doxygen>